
import javax.microedition.midlet.MIDlet;
import javax.microedition.midlet.MIDletStateChangeException;
import javax.microedition.lcdui.*;
import javax.microedition.io.HttpConnection;
import javax.microedition.io.Connector;
import java.io.*;

public class SessionTracker extends MIDlet implements CommandListener {

    private Command cookieCommand = new Command("Cookie", Command.OK, 1);
    private Command protocolCommand = new Command("Protocol", Command.OK, 1);
    private Command exitCommand = new Command("Konec", Command.EXIT, 1);

    private static Display display;
    private static String sessionIDStr;
    private static String sessionProtocolStr;

    public SessionTracker() {
        display = Display.getDisplay(this);

        init();
    }

    private void init() {
        display.setCurrent(getMenu(""));
    }

    protected void startApp() throws MIDletStateChangeException {
    }

    protected void pauseApp() {
    }

    protected void destroyApp(boolean b) throws MIDletStateChangeException {
    }

    // Command event handler
    public void commandAction(Command command, Displayable displayable) {
        if (command == exitCommand) {
            notifyDestroyed();
        } else if (command == cookieCommand) {
            display.setCurrent(getMenu(connectByCookie()));
        } else if (command == protocolCommand) {
            display.setCurrent(getMenu(connectByProtocol()));
        }
    }

    private Form getMenu(String text) {
        Form menu = new Form("Menu");

        menu.append(text);

        menu.addCommand(cookieCommand);
        menu.addCommand(protocolCommand);
        menu.addCommand(exitCommand);
        menu.setCommandListener(this);

        return menu;
    }

    private String connectByCookie() {

        HttpConnection con = null;
        InputStream in = null;

        ByteArrayOutputStream baos = new ByteArrayOutputStream();

        int read;

        try {
            con = (HttpConnection) Connector.open("http://localhost:80/sessionservlets/cookie", Connector.READ, true);
            //Set the request method
            con.setRequestMethod(HttpConnection.POST);
            con.setRequestProperty("User-Agent", "Profile/MIDP-1.0 Configuration/CLDC-1.0");
            con.setRequestProperty("Content-Type", "plain/text");
            //con.setRequestProperty("Content-Length", String.valueOf(bytes.length));

            if (sessionIDStr != null) {
                setCookiesSession(con);
            }

            in = con.openInputStream();

            // Process the data
            if (sessionIDStr == null) {
                getCookiesSession(con);
            }

            while ((read = in.read()) != -1) {
                baos.write(read);
            }

            System.out.println(baos.toString());

        } catch (IOException e) {
            e.printStackTrace();
        } finally {
            if (in != null) {
                try {
                    in.close();
                } catch (IOException e) {
                    //ignore it
                }

                in = null;
            }

            if (con != null) {
                try {
                    con.close();
                } catch (IOException e) {
                    //ignore it
                }

                con = null;
            }
        }

        return baos.toString();
    }

    private String connectByProtocol() {

        HttpConnection con = null;
        DataInputStream dis = null;
        String response = "";

        try {
            con = (HttpConnection) Connector.open("http://localhost:80/sessionservlets/protocol", Connector.READ_WRITE, true);
            //Set the request method
            con.setRequestMethod(HttpConnection.POST);
            con.setRequestProperty("User-Agent", "Profile/MIDP-1.0 Configuration/CLDC-1.0");
            con.setRequestProperty("Content-Type", "plain/text");
            //con.setRequestProperty("Content-Length", String.valueOf(bytes.length));

            DataOutputStream dos = new DataOutputStream(con.openOutputStream());
            dos.writeUTF((sessionProtocolStr != null)? sessionProtocolStr : "");

            dis = new DataInputStream(con.openInputStream());

            sessionProtocolStr = dis.readUTF();

            response = "Counter = " + dis.readInt();
        } catch (IOException e) {
            e.printStackTrace();
        } finally {
            if (dis != null) {
                try {
                    dis.close();
                } catch (IOException e) {
                    //ignore it
                }

                dis = null;
            }

            if (con != null) {
                try {
                    con.close();
                } catch (IOException e) {
                    //ignore it
                }

                con = null;
            }
        }

        return response;
    }

    private void getCookiesSession(HttpConnection con) throws IOException {
        int headerIndex = 0;
        while (con.getHeaderFieldKey(headerIndex) != null) {
            String headerFieldKey = con.getHeaderFieldKey(headerIndex);
            if (headerFieldKey.equals("set-cookie")) {
                String value = con.getHeaderField(headerFieldKey);
                sessionIDStr = "JSESSIONID=" + value.substring(value.indexOf('=') + 1, value.length());
            }

            headerIndex++;
        }
    }

    private void setCookiesSession(HttpConnection con) throws IOException {
        con.setRequestProperty("cookie", sessionIDStr);
    }
}
