
import javax.servlet.http.*;
import javax.servlet.ServletException;
import java.io.IOException;
import java.io.PrintWriter;

public class CookieServlet extends HttpServlet {

    protected void doGet(HttpServletRequest httpServletRequest, HttpServletResponse httpServletResponse) throws ServletException, IOException {
        processRequest(httpServletRequest, httpServletResponse);
    }

    protected void doPost(HttpServletRequest httpServletRequest, HttpServletResponse httpServletResponse) throws ServletException, IOException {
        processRequest(httpServletRequest, httpServletResponse);
    }

    protected void processRequest(HttpServletRequest req, HttpServletResponse res) throws ServletException, IOException {

        // vytvor novou session pokud je to nutne
        HttpSession session = req.getSession(true);

        if (session.isNew()) {
            System.out.println("Created new session: " + session.getId());
            // nastav cookie HTTP protokolu, musi byt provedeno jeste pred ziskanim PrintWriteru
            res.addCookie(new Cookie("session", session.getId()));
        }

        // ziskej atribut pocitadla
        String counterStr = (String) session.getAttribute("counter");

        // ziskej printwriter objekt
        PrintWriter pw = res.getWriter();

        // nastav defaultni hodnotu pocitadla
        if (counterStr == null) {
            counterStr = "0";
        }

        // inkrementuj pocitadlo
        counterStr = "" + (Integer.valueOf(counterStr).intValue() + 1);

        // nastav atribut pocitadla
        session.setAttribute("counter", counterStr);

        // zapis aktualni hodnotu pocitadla
        pw.println("Counter = " + counterStr);
    }
}
