
import javax.servlet.http.*;
import javax.servlet.ServletException;
import java.io.*;
import java.util.Hashtable;

public class ProtocolServlet extends HttpServlet {

    private static Hashtable sessions;

    public void init() throws ServletException {
        super.init();

        System.out.println("Creating cache");
        sessions = new Hashtable();
    }

    protected void doGet(HttpServletRequest httpServletRequest, HttpServletResponse httpServletResponse) throws ServletException, IOException {
        processRequest(httpServletRequest, httpServletResponse);
    }

    protected void doPost(HttpServletRequest httpServletRequest, HttpServletResponse httpServletResponse) throws ServletException, IOException {
        processRequest(httpServletRequest, httpServletResponse);
    }

    protected void processRequest(HttpServletRequest req, HttpServletResponse res) throws ServletException, IOException {

        HttpSession session = null;

        ByteArrayOutputStream baos = new ByteArrayOutputStream();
        DataOutputStream dos = new DataOutputStream(baos);

        DataInputStream dis = new DataInputStream(req.getInputStream());
        String ID = dis.readUTF();

        dis.close();

        boolean empty = ID.equals("");

        System.out.println("ID = '" + ID + "'" + " is empty string " + empty);

        if (empty) {
            session = req.getSession(true);
            sessions.put(session.getId(), session);
            System.out.println("Created new protocol session: " + session.getId());
        } else {
            System.out.println("Retrieving session ID" + ID);
            session = (HttpSession) sessions.get(ID);
        }

        System.out.println("Session is null " + (session == null));

        // ziskej atribut pocitadla
        String counterStr = (String) session.getAttribute("counter");

        // ziskej outputstream objekt
        OutputStream os = res.getOutputStream();

        // nastav defaultni hodnotu pocitadla
        if (counterStr == null) {
            counterStr = "0";
        }

        // inkrementuj pocitadlo
        int counter = (Integer.valueOf(counterStr).intValue() + 1);
        counterStr = "" + counter;

        // nastav atribut pocitadla
        session.setAttribute("counter", counterStr);

        dos.writeUTF(session.getId());
        dos.writeInt(counter);
        dos.close();

        // zapis aktualni hodnotu pocitadla
        os.write(baos.toByteArray());
        os.close();
        //*/
    }
}
